%global _localbindir %{_exec_prefix}/local/bin

Summary: Utility to manage multiple Java versions
Name: java-launcher
Version: 0.2.3
Release: 1%{?dist}
Group: System Environment/Base
License: GPL-2.0-or-later
Packager: Simon Matter <simon.matter@invoca.ch>
Vendor: Invoca Systems
Distribution: Invoca Linux Server
Source0: java-launcher.sh
Requires: coreutils
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
Java-launcher helps you to manage multiple Java versions installed as part
of the OS (managed by `alternatives') and also Java installations in
/opt/java/default/ or elsewhere.

%build
%{_buildshell} %{SOURCE0} -h 2> README

%install
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%{__install} -d %{buildroot}%{_bindir}
%{__install} -d %{buildroot}%{_localbindir}
%{__install} -d %{buildroot}/opt/java

%{__install} -p -m 0755 %{SOURCE0} %{buildroot}%{_bindir}/%{name}

# This list includes all possible names of binaries in Java. It needs to be
# updated for new Java versions and should currently cover versions 11..19.
BINARIES="jaotc
jar
jarsigner
java
javac
javadoc
javap
jcmd
jconsole
jdb
jdeprscan
jdeps
jdmpview
jextract
jfr
jhsdb
jimage
jinfo
jitserver
jjs
jlink
jmap
jmod
jpackage
jpackcore
jps
jrunscript
jshell
jstack
jstat
jstatd
jwebserver
keytool
pack200
rmic
rmid
rmiregistry
serialver
traceformat
unpack200"

while read -rs TARGET; do
  %{__ln_s} ../../bin/java-launcher %{buildroot}%{_localbindir}/${TARGET}
done <<< "$BINARIES"

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc README
%{_bindir}/%{name}
%{_localbindir}/*
%dir /opt/java

%changelog
* Wed Apr 17 2024 Simon Matter <simon.matter@invoca.ch> 0.2.3-1
- upgrade to 0.2.3
- change to SPDX license tag
- generate README file

* Wed Feb 01 2023 Simon Matter <simon.matter@invoca.ch> 0.2.2-1
- upgrade to 0.2.2

* Tue Jan 31 2023 Simon Matter <simon.matter@invoca.ch> 0.2.1-1
- upgrade to 0.2.1

* Tue Jan 31 2023 Simon Matter <simon.matter@invoca.ch> 0.2.0-1
- upgrade to 0.2.0

* Mon Jan 30 2023 Simon Matter <simon.matter@invoca.ch> 0.1.0-1
- initial build
